library ExecStr;

Uses WinTypes, WinProcs, Strings;

type

{
Prototype callback functions to be used
}
  ExecuteStringType = function(Exe_String, Other_String: PChar; W1, W2: word):
PChar;
  PutValueType = function(Field, Value: PChar): PChar;

var
  CharArray:array[0..100] of Char;

{
   This function uses the Execute String parameter to call ObjectVision's @Message
   function and also registers a new @function called PutValue listed below.
}

function RegisterCallBack(CallBackString: ExecuteStringType): Integer; export;
begin
CallBackString('@Message("Successful Registration from Pascal")','', 0, 0);
                               {call the OV message function}

CallBackString('@REGISTER("@PUTVALUE","IwCC","","EXEC.DLL","PUTVALUE
",1
        )','', 0, 0); { Register a new @ function for object Vision }
  RegisterCallBack := 1;
end;

{
   This function receives the Callback function address in the parameter variable "Put".
   It then uses that variable to with the correct parameters to place a value in a certain
   field
}
function PutValue(Put:PutValueType; Field, Value: PChar): Integer; export;
begin
  Put(Field,Value);
  MessageBox(GetFocus, 'Placed By Your DLL', 'Info', MB_Ok);
 end;

exports
  RegisterCallBack  index 1,
  PutValue              index 2;

begin
end.
